using CoreLibrary.Evenements;
using CoreLibrary.Joueurs;

namespace MauiSpark.Pages;

/// <summary>
/// Page de connexions o l'on rentre les joueurs de la partie
/// </summary>
public partial class ConnexionPage : ContentPage
{
    /// <summary>
    /// Indice du joueur  rentr
    /// </summary>
	private int? indice;

    /// <summary>
    /// Le joueur qui est demand
    /// </summary>
    private Joueur? joueurDemande;
  
    /// <summary>
    /// Constructeur pour la page de connexions
    /// </summary>
    public ConnexionPage()
	{
		NavigationPage.SetHasNavigationBar(this, false);

        InitializeComponent();
    }

    /// <summary>
    /// Mthode dclenche quand l'vnement DemanderNom de partie est appele
    /// </summary>
    /// <param name="sender">La class qui appelle l'venement; ici Partie </param>
    /// <param name="e">L'instance de l'vnement PartieDemanderJoueurEventArgs cre par Partie</param>
	public async void QuandDemanderNom(Object? sender, PartieDemanderJoueurEventArgs e)
	{
		if(Application.Current != null && Application.Current.MainPage != null && ((NavigationPage)Application.Current.MainPage).CurrentPage != this)
			await Application.Current.MainPage.Navigation.PushAsync(this);

		Nom.Text = "";
		indice = e.Indice;
        joueurDemande = e.JoueurDemande;
        BindingContext = $"Joueur {e.Indice}";
	}

    /// <summary>
    /// Mthode dclench quand le buton jou est cliqu.
    /// </summary>
    /// <param name="sender">L'object qui appelle l'venement; ici le buton SeConnecterPresse</param>
    /// <param name="e">L'instance de l'vnement EventArgs cre par le systme</param>
	private void QuandSeConnecterPresse(Object sender, EventArgs e)
	{
        if (joueurDemande == null || indice == null)
            return;

        if (string.IsNullOrEmpty(Nom.Text))
        {
            joueurDemande.SeConnecter(new Joueur($"Joueur {indice.Value}"));
        }
        else
        {
            joueurDemande.SeConnecter(MauiProgram.Manageur.DemanderJoueur(Nom.Text));
        }
    }
}